Index: c/src/ChangeLog
===================================================================
--- c/src/ChangeLog	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/ChangeLog	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -1,2 +1,11 @@
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* libchip/i2c/spi-flash-m25p40.c, libchip/i2c/spi-flash-m25p40.h,
+	* libchip/i2c/spi-fram-fm25l256.c, libchip/i2c/spi-fram-fm25l256.h,
+	* libchip/i2c/spi-memdrv.c, libchip/i2c/spi-memdrv.h,
+	* libchip/Makefile.am:
+	derived a generic spi memory driver from spi-flash-m25p40, 
+	added descriptor for fram fm25l256
+
 2008-05-07	Till Straumann <strauman@slac.stanford.edu>
 
Index: c/src/lib/libbsp/arm/edb7312/preinstall.am
===================================================================
--- c/src/lib/libbsp/arm/edb7312/preinstall.am	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/arm/edb7312/preinstall.am	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -69,2 +69,6 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/irq.h
 
+$(PROJECT_INCLUDE)/irq.h: irq/irq.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/irq.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/irq.h
+
Index: c/src/lib/libbsp/bfin/eZKit533/preinstall.am
===================================================================
--- c/src/lib/libbsp/bfin/eZKit533/preinstall.am	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/bfin/eZKit533/preinstall.am	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -37,8 +37,4 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp.h
 
-$(PROJECT_INCLUDE)/cplb.h: include/cplb.h $(PROJECT_INCLUDE)/$(dirstamp)
-	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/cplb.h
-PREINSTALL_FILES += $(PROJECT_INCLUDE)/cplb.h
-
 $(PROJECT_INCLUDE)/tm27.h: include/tm27.h $(PROJECT_INCLUDE)/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/tm27.h
Index: c/src/lib/libbsp/powerpc/gen83xx/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/ChangeLog	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/ChangeLog	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -1,2 +1,35 @@
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* network/network.c, start/start.S:
+	add support for different board
+
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* irq/ipic.c:
+	make sure, that the masking operations in 
+	ICTL and MSR are executed in order
+
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* include/bsp.h, startup/bspstart.c, 
+	* console/console.c, console/config.c:
+	derived module input frequencies from internal bus clock during
+	start time
+
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* spi/spi_init.c:
+	added base frequency into softc structure, added fm25l256 driver
+
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* i2c/i2c_init.c:
+	added base frequency into softc structure
+
+2008-05-15	Thomas Doerfler <Thomas.Doerfler@embedded-brains.de>
+
+	* include/bsp.h, include/hwreg_vals.h, ./Makefile.am: 
+	moved HW register settings from bsp.h to hwreg_vals.h
+
 2008-05-14	Joel Sherrill <joel.sherrill@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/gen83xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -46,5 +46,7 @@
 
 include_bsp_HEADERS = ./irq/irq.h \
+    ./include/hwreg_vals.h        \
     ../../powerpc/shared/vectors/vectors.h
+
 vectors_SOURCES = ../../powerpc/shared/vectors/vectors.h \
     ../../powerpc/shared/vectors/vectors_init.c \
Index: c/src/lib/libbsp/powerpc/gen83xx/console/config.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/console/config.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/console/config.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -106,8 +106,9 @@
 		NULL,				/* getData */
 		NULL,				/* setData */
-		BSP_CSB_CLK_FRQ,		/* ulClock */
+		0,		                /* ulClock (filled in init) */
                 0				/* ulIntVector */
-	},
-        {
+	}
+#if BSP_USE_UART2
+        ,{
                 "/dev/ttyS1",                   /* sDeviceName */
                 SERIAL_NS16550,                 /* deviceType */
@@ -125,7 +126,8 @@
                 NULL,                           /* getData */
                 NULL,                           /* setData */
-                BSP_CSB_CLK_FRQ,                /* ulClock */
+		0,		                /* ulClock (filled in init) */
                 0                               /* ulIntVector */
         }
+#endif
 };
 
Index: c/src/lib/libbsp/powerpc/gen83xx/console/console.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/console/console.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/console/console.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -174,4 +174,9 @@
   {
     /*
+     * transfer the real internal bus frequency into the 
+     * console port table
+     */
+    Console_Port_Tbl[minor].ulClock = BSP_bus_frequency;
+    /*
      * First perform the configuration dependant probe, then the
      * device dependant probe
Index: c/src/lib/libbsp/powerpc/gen83xx/i2c/i2c_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/i2c/i2c_init.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/i2c/i2c_init.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -32,5 +32,6 @@
       reg_ptr:	 &mpc83xx.i2c[0],
       initialized: FALSE,
-      irq_number:  BSP_IPIC_IRQ_I2C1
+      irq_number :  BSP_IPIC_IRQ_I2C1,
+      base_frq   : 0 /* will be set during initiailization */
     }
   },
@@ -44,5 +45,6 @@
       reg_ptr:	 &mpc83xx.i2c[1],
       initialized: FALSE,
-      irq_number:  BSP_IPIC_IRQ_I2C2
+      irq_number :  BSP_IPIC_IRQ_I2C2,
+      base_frq   : 0 /* will be set during initiailization */
     }
   } 
@@ -82,4 +84,17 @@
 
   /*
+   * update input frequency of I2c modules into descriptor
+   */
+  /*
+   * I2C1 is clocked with TSEC 1
+   */
+  if (((mpc83xx.clk.sccr >> (31-1)) & 0x03) > 0) {
+    mpc83xx_i2c_bus_tbl[0].softc.base_frq = 
+      (BSP_bus_frequency
+       /((mpc83xx.clk.sccr >> (31-1)) & 0x03));
+  }
+
+  mpc83xx_i2c_bus_tbl[1].softc.base_frq = BSP_bus_frequency;
+  /*
    * register first I2C bus
    */
@@ -99,4 +114,5 @@
   }
   i2c2_busno = ret_code;
+
   /*
    * register EEPROM to bus 1, Address 0x50
@@ -108,4 +124,5 @@
     return -ret_code;
   }
+
   /*
    * FIXME: register RTC driver, when available
Index: c/src/lib/libbsp/powerpc/gen83xx/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/include/bsp.h	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/include/bsp.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -21,164 +21,5 @@
 #define __GEN83xx_BSP_h
 
-/*
- * distinguish board characteristics
- */
-/*
- * for Freescale MPC8349 EAMDS
- */
-#if defined(MPC8349EAMDS)
-/*
- * two DUART channels supported
- */
-#define GEN83xx_DUART_AVAIL_MASK 0x03
-
-/* we need the low level initialization in start.S*/
-#define NEED_LOW_LEVEL_INIT
-/*
- * clocking infos
- */
-#define BSP_CLKIN_FRQ 66000000L
-#define BSP_SYSPLL_MF 4 /* FIXME: derive from clock register */
-
-/*
- * Reset configuration words
- */
-#define RESET_CONF_WRD_L (RCWLR_LBIUCM_1_1 |	\
-			  RCWLR_DDRCM_1_1  |	\
-			  RCWLR_SPMF(4)    |	\
-			  RCWLR_COREPLL(4))
-
-#define RESET_CONF_WRD_H (RCWHR_PCI_HOST     |	\
-			  RCWHR_PCI_32       |	\
-			  RCWHR_PCI1ARB_EN   |	\
-			  RCWHR_PCI2ARB_EN   |	\
-			  RCWHR_CORE_EN      |	\
-			  RCWHR_BMS_LOW      |	\
-			  RCWHR_BOOTSEQ_NONE |	\
-			  RCWHR_SW_DIS       |	\
-			  RCWHR_ROMLOC_LB16  |	\
-			  RCWHR_TSEC1M_GMII  |	\
-			  RCWHR_TSEC2M_GMII  |	\
-			  RCWHR_ENDIAN_BIG   |	\
-			  RCWHR_LALE_NORM    |	\
-			  RCWHR_LDP_PAR)
-/*
- * for JPK HSC_CM01
- */
-#elif defined(HSC_CM01)
-/*
- * one DUART channel (UART1) supported
- */
-#define GEN83xx_DUART_AVAIL_MASK 0x01
-
-/* we need the low level initialization in start.S*/
-#define NEED_LOW_LEVEL_INIT
-/*
- * clocking infos
- */
-#define BSP_CLKIN_FRQ 66000000L
-#define BSP_SYSPLL_MF 4 /* FIXME: derive from clock register */
-
-/*
- * Reset configuration words
- */
-#define RESET_CONF_WRD_L (RCWLR_LBIUCM_1_1 |	\
-			  RCWLR_DDRCM_1_1  |	\
-			  RCWLR_SPMF(4)    |	\
-			  RCWLR_COREPLL(4))
-
-#define RESET_CONF_WRD_H (RCWHR_PCI_HOST     |	\
-			  RCWHR_PCI_32       |	\
-			  RCWHR_PCI1ARB_EN   |	\
-			  RCWHR_PCI2ARB_EN   |	\
-			  RCWHR_CORE_EN      |	\
-			  RCWHR_BMS_LOW      |	\
-			  RCWHR_BOOTSEQ_NONE |	\
-			  RCWHR_SW_DIS       |	\
-			  RCWHR_ROMLOC_LB16  |	\
-			  RCWHR_TSEC1M_RGMII |	\
-			  RCWHR_TSEC2M_GMII  |	\
-			  RCWHR_ENDIAN_BIG   |	\
-			  RCWHR_LALE_NORM    |	\
-			  RCWHR_LDP_PAR)
-#else
-#error "board type not defined"
-#endif
-
-/*
- * for JPK HSC_CM01 and freescale MPC8349EAMDS
- */
-#if defined(MPC8349EAMDS) || defined(HSC_CM01)
-/*
- * address range definitions
- */
-/* ROM definitions (8 MB, mirrored multiple times) */
-#define	ROM_START	0xFE000000
-#define ROM_SIZE        0x02000000
-#define	ROM_END		(ROM_START+ROM_SIZE-1)
-#define	BOOT_START      ROM_START
-#define	BOOT_END        ROM_END
-
-/* SDRAM definitions (256 MB) */
-#define	RAM_START       0x00000000
-#define RAM_SIZE        0x10000000
-#define	RAM_END		(RAM_START+RAM_SIZE-1)
-
-
-/* working internal memory map base address */
-#define	IMMRBAR         0xE0000000
-
-/*
- * working values for various registers, used in start/start.S
- */
-/*
- * Local Access Windows
- * FIXME: decode bit settings 
- */
-#define LBLAWBAR0_VAL  0xFE000000
-#define LBLAWAR0_VAL   0x80000016
-#define LBLAWBAR1_VAL  0xF8000000
-#define LBLAWAR1_VAL   0x8000000E
-#define LBLAWBAR2_VAL  0xF0000000
-#define LBLAWAR2_VAL   0x80000019
-#define DDRLAWBAR0_VAL 0x00000000
-#define DDRLAWAR0_VAL  0x8000001B
-/*
- * Local Bus (Memory) Controller
- * FIXME: decode bit settings 
- */
-#define BR0_VAL 0xFE001001
-#define OR0_VAL 0xFF806FF7
-#define BR1_VAL 0xF8000801
-#define OR1_VAL 0xFFFFE8F0
-#define BR2_VAL 0xF0001861
-#define OR2_VAL 0xFC006901
-/*
- * SDRAM registers
- * FIXME: decode bit settings 
- */
-#define MRPTR_VAL 0x20000000
-#define LSRT_VAL  0x32000000
-#define LSDMR_VAL 0x4062D733
-#define LCRR_VAL  0x80000004
-
-/*
- * DDR-SDRAM registers
- * FIXME: decode bit settings 
- */
-#define CS2_BNDS_VAL                 0x00000007
-#define CS3_BNDS_VAL                 0x0008000F
-#define CS2_CONFIG_VAL               0x80000101
-#define CS3_CONFIG_VAL               0x80000101
-#define TIMING_CFG_1_VAL             0x36333321
-#define TIMING_CFG_2_VAL             0x00000800
-#define DDR_SDRAM_CFG_VAL            0xC2000000
-#define DDR_SDRAM_MODE_VAL           0x00000022
-#define DDR_SDRAM_INTTVL_VAL         0x045B0100
-#define DDR_SDRAM_CLK_CNTL_VAL       0x00000000
-
-#else
-#error "board type not defined"
-#endif
+#include <bsp/hwreg_vals.h>
 
 #ifndef ASM
@@ -247,4 +88,10 @@
 #define PRINTK_MINOR BSP_UART1_MINOR
 
+#if defined(MPC8249EAMDS)
+#define BSP_USE_UART2 TRUE
+#else
+#define BSP_USE_UART2 FALSE
+#endif
+
 #define SINGLE_CHAR_MODE
 #define UARTS_USE_TERMIOS_INT   1
@@ -261,7 +108,8 @@
  *   (int) ((float)(_value) / ((XLB_CLOCK/1000000 * 0.1) / 4.0))
  */
-#define BSP_CSB_CLK_FRQ (BSP_CLKIN_FRQ * BSP_SYSPLL_MF)
+
+extern unsigned int BSP_bus_frequency;
 #define BSP_Convert_decrementer( _value ) \
-  (int) (((_value) * 4000) / (BSP_CSB_CLK_FRQ/10000))
+  (int) (((_value) * 4000) / (BSP_bus_frequency/10000))
 
 /*
@@ -275,4 +123,5 @@
 #define RTEMS_BSP_NETWORK_DRIVER_NAME2	"tsec2"
 
+#if defined(MPC8349EAMDS)
 /*
  * i2c EEPROM device name
@@ -286,4 +135,19 @@
 #define RTEMS_BSP_SPI_FLASH_DEVICE_NAME "flash"
 #define RTEMS_BSP_SPI_FLASH_DEVICE_PATH "/dev/spi.flash"
+#endif /* defined(MPC8349EAMDS) */
+
+#if defined(HSC_CM01)
+/*
+ * i2c EEPROM device name
+ */
+#define RTEMS_BSP_I2C_EEPROM_DEVICE_NAME "eeprom"
+#define RTEMS_BSP_I2C_EEPROM_DEVICE_PATH "/dev/i2c1.eeprom"
+
+/*
+ * SPI FRAM device name
+ */
+#define RTEMS_BSP_SPI_FRAM_DEVICE_NAME "fram"
+#define RTEMS_BSP_SPI_FRAM_DEVICE_PATH "/dev/spi.fram"
+#endif /* defined(HSC_CM01) */
 
 #ifdef __cplusplus
Index: c/src/lib/libbsp/powerpc/gen83xx/include/hwreg_vals.h
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/include/hwreg_vals.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
+++ c/src/lib/libbsp/powerpc/gen83xx/include/hwreg_vals.h	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -0,0 +1,268 @@
+/*===============================================================*\
+| Project: RTEMS generic MPC83xx BSP                              |
++-----------------------------------------------------------------+
+|                    Copyright (c) 2007                           |
+|                    Embedded Brains GmbH                         |
+|                    Obere Lagerstr. 30                           |
+|                    D-82178 Puchheim                             |
+|                    Germany                                      |
+|                    rtems@embedded-brains.de                     |
++-----------------------------------------------------------------+
+| The license and distribution terms for this file may be         |
+| found in the file LICENSE in this distribution or at            |
+|                                                                 |
+| http://www.rtems.com/license/LICENSE.                           |
+|                                                                 |
++-----------------------------------------------------------------+
+| this file contains board specific definitions                   |
+\*===============================================================*/
+
+#ifndef __GEN83xx_HWREG_VALS_h
+#define __GEN83xx_HWREG_VALS_h
+
+#include <mpc83xx/mpc83xx.h>
+/*
+ * distinguish board characteristics
+ */
+#if defined(MPC8349EAMDS)
+/*
+ * for Freescale MPC8349 EAMDS
+ */
+/*
+ * two DUART channels supported
+ */
+#define GEN83xx_DUART_AVAIL_MASK 0x03
+
+/* we need the low level initialization in start.S*/
+#define NEED_LOW_LEVEL_INIT
+/*
+ * clocking infos
+ */
+#define BSP_CLKIN_FRQ 66000000L
+#define RCFG_SYSPLL_MF 4 
+#define RCFG_COREPLL_MF 4
+
+/*
+ * Reset configuration words
+ */
+#define RESET_CONF_WRD_L (RCWLR_LBIUCM_1_1 |	\
+			  RCWLR_DDRCM_1_1  |	\
+			  RCWLR_SPMF(RCFG_SYSPLL_MF)    |	\
+			  RCWLR_COREPLL(RCFG_COREPLL_MF))
+
+#define RESET_CONF_WRD_H (RCWHR_PCI_HOST     |	\
+			  RCWHR_PCI_32       |	\
+			  RCWHR_PCI1ARB_EN   |	\
+			  RCWHR_PCI2ARB_EN   |	\
+			  RCWHR_CORE_EN      |	\
+			  RCWHR_BMS_LOW      |	\
+			  RCWHR_BOOTSEQ_NONE |	\
+			  RCWHR_SW_DIS       |	\
+			  RCWHR_ROMLOC_LB16  |	\
+			  RCWHR_TSEC1M_GMII  |	\
+			  RCWHR_TSEC2M_GMII  |	\
+			  RCWHR_ENDIAN_BIG   |	\
+			  RCWHR_LALE_NORM    |	\
+			  RCWHR_LDP_PAR)
+#elif defined(HSC_CM01)
+/*
+ * for JPK HSC_CM01
+ */
+/*
+ * one DUART channel (UART1) supported
+ */
+#define GEN83xx_DUART_AVAIL_MASK 0x01
+
+/* we need the low level initialization in start.S*/
+#define NEED_LOW_LEVEL_INIT
+/*
+ * clocking infos
+ */
+#define BSP_CLKIN_FRQ 30000000L
+#define RCFG_SYSPLL_MF 11 
+#define RCFG_COREPLL_MF 4
+/*
+ * Reset configuration words
+ */
+#define RESET_CONF_WRD_L (RCWLR_LBIUCM_1_1 |	\
+			  RCWLR_DDRCM_1_1  |	\
+			  RCWLR_SPMF(RCFG_SYSPLL_MF)    |	\
+			  RCWLR_COREPLL(RCFG_COREPLL_MF))
+
+#define RESET_CONF_WRD_H (RCWHR_PCI_HOST     |	\
+			  RCWHR_PCI_32       |	\
+			  RCWHR_PCI1ARB_EN   |	\
+			  RCWHR_PCI2ARB_EN   |	\
+			  RCWHR_CORE_EN      |	\
+			  RCWHR_BMS_LOW      |	\
+			  RCWHR_BOOTSEQ_NONE |	\
+			  RCWHR_SW_DIS       |	\
+			  RCWHR_ROMLOC_LB16  |	\
+			  RCWHR_TSEC1M_RGMII |	\
+			  RCWHR_TSEC2M_GMII  |	\
+			  RCWHR_ENDIAN_BIG   |	\
+			  RCWHR_LALE_NORM    |	\
+			  RCWHR_LDP_PAR)
+#else
+#error "board type not defined"
+#endif
+
+#if defined(MPC8349EAMDS) 
+/**************************
+ * for Freescale MPC8349EAMDS
+ */
+/*
+ * address range definitions
+ */
+/* ROM definitions (8 MB, mirrored multiple times) */
+#define	ROM_START	0xFE000000
+#define ROM_SIZE        0x02000000
+#define	ROM_END		(ROM_START+ROM_SIZE-1)
+#define	BOOT_START      ROM_START
+#define	BOOT_END        ROM_END
+
+/* SDRAM definitions (256 MB) */
+#define	RAM_START       0x00000000
+#define RAM_SIZE        0x10000000
+#define	RAM_END		(RAM_START+RAM_SIZE-1)
+
+
+/* working internal memory map base address */
+#define	IMMRBAR         0xE0000000
+
+/*
+ * working values for various registers, used in start/start.S
+ */
+/*
+ * Local Access Windows
+ * FIXME: decode bit settings 
+ */
+#define LBLAWBAR0_VAL  0xFE000000
+#define LBLAWAR0_VAL   0x80000016
+#define LBLAWBAR1_VAL  0xF8000000
+#define LBLAWAR1_VAL   0x8000000E
+#define LBLAWBAR2_VAL  0xF0000000
+#define LBLAWAR2_VAL   0x80000019
+#define DDRLAWBAR0_VAL 0x00000000
+#define DDRLAWAR0_VAL  0x8000001B
+/*
+ * Local Bus (Memory) Controller
+ * FIXME: decode bit settings 
+ */
+#define BR0_VAL 0xFE001001
+#define OR0_VAL 0xFF806FF7
+#define BR1_VAL 0xF8000801
+#define OR1_VAL 0xFFFFE8F0
+#define BR2_VAL 0xF0001861
+#define OR2_VAL 0xFC006901
+/*
+ * SDRAM registers
+ * FIXME: decode bit settings 
+ */
+#define MRPTR_VAL 0x20000000
+#define LSRT_VAL  0x32000000
+#define LSDMR_VAL 0x4062D733
+#define LCRR_VAL  0x80000004
+
+/*
+ * DDR-SDRAM registers
+ * FIXME: decode bit settings 
+ */
+#define CS2_BNDS_VAL                 0x00000007
+#define CS3_BNDS_VAL                 0x0008000F
+#define CS2_CONFIG_VAL               0x80000101
+#define CS3_CONFIG_VAL               0x80000101
+#define TIMING_CFG_1_VAL             0x36333321
+#define TIMING_CFG_2_VAL             0x00000800
+#define DDR_SDRAM_CFG_VAL            0xC2000000
+#define DDR_SDRAM_MODE_VAL           0x00000022
+#define DDR_SDRAM_INTTVL_VAL         0x045B0100
+#define DDR_SDRAM_CLK_CNTL_VAL       0x00000000
+
+#elif defined(HSC_CM01)
+/**************************
+ * for JPK HSC_CM01
+ */
+/*
+ * address range definitions
+ */
+/* ROM definitions (8 MB, mirrored multiple times) */
+#define	ROM_START	0xFE000000
+#define ROM_SIZE        0x02000000
+#define	ROM_END		(ROM_START+ROM_SIZE-1)
+#define	BOOT_START      ROM_START
+#define	BOOT_END        ROM_END
+
+/* SDRAM definitions (256 MB) */
+#define	RAM_START       0x00000000
+#define RAM_SIZE        0x10000000
+#define	RAM_END		(RAM_START+RAM_SIZE-1)
+
+
+/* working internal memory map base address */
+#define	IMMRBAR         0xE0000000
+
+/*
+ * working values for various registers, used in start/start.S
+ */
+/*
+ * Local Access Windows
+ * FIXME: decode bit settings 
+ */
+
+#define LBLAWBAR0_VAL  ROM_START
+#define LBLAWAR0_VAL   0x80000018
+#define LBLAWBAR1_VAL  0xF8000000
+#define LBLAWAR1_VAL   0x80000015
+#define DDRLAWBAR0_VAL RAM_START
+#define DDRLAWAR0_VAL  0x8000001B
+/*
+ * Local Bus (Memory) Controller
+ * FIXME: decode bit settings 
+ */
+#define BR0_VAL 0xFE001001
+#define OR0_VAL 0xFE000E54
+#define BR3_VAL 0xF8001881
+#define OR3_VAL 0xFFC01100
+/*
+ * Local (memory) bus divider
+ * FIXME: decode bit settings 
+ */
+#define LCRR_VAL  0x00010004
+
+/*
+ * DDR-SDRAM registers
+ * FIXME: decode bit settings 
+ */
+#define DDRCDR_VAL                   0x00000001
+#define CS0_BNDS_VAL                 0x0000000F
+#define CS0_CONFIG_VAL               0x80810102
+#define TIMING_CFG_0_VAL             0x00420802
+#define TIMING_CFG_1_VAL             0x3735A322
+#define TIMING_CFG_2_VAL             0x2F9044C7
+#define DDR_SDRAM_CFG_2_VAL          0x00401000
+#define DDR_SDRAM_MODE_VAL           0x44521632
+#define DDR_SDRAM_CLK_CNTL_VAL       0x01800000
+#define DDR_SDRAM_CFG_VAL            0x43000008
+
+#define DDR_ERR_DISABLE_VAL          0x0000008D
+#define DDR_ERR_DISABLE_VAL2         0x00000089
+#define DDR_SDRAM_DATA_INIT_VAL      0xC01DCAFE
+#define DDR_SDRAM_INIT_ADDR_VAL      0
+#define DDR_SDRAM_INTERVAL_VAL       0x05080000
+#else
+#error "board type not defined"
+#endif
+
+
+/**************************
+ * derived values for all boards
+ */
+/* value of input clock divider (derived from pll mode reg) */
+#define BSP_SYSPLL_CKID (((mpc83xx.clk.spmr>>(31-8))&0x01)+1)
+/* value of system pll (derived from pll mode reg) */
+#define BSP_SYSPLL_MF    ((mpc83xx.clk.spmr>>(31-7))&0x0f) 
+/* value of system pll (derived from pll mode reg) */
+#define BSP_COREPLL_MF   ((mpc83xx.clk.spmr>>(31-15))&0x7f) 
+
+#endif /* __GEN83xx_HWREG_VALS_h */
Index: c/src/lib/libbsp/powerpc/gen83xx/irq/ipic.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/irq/ipic.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/irq/ipic.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -273,4 +273,11 @@
     mpc83xx.ipic.semsr    &= mask_ptr->semsr_mask   ;
     mpc83xx.ipic.sermr    &= mask_ptr->sermr_mask   ;
+
+    /* 
+     * make sure, that the masking operations in 
+     * ICTL and MSR are executed in order
+     */
+    asm volatile("sync":::"memory");
+    
     /*
      * reenable msr_ee
@@ -294,4 +301,11 @@
      */
     _CPU_MSR_SET(msr_save);
+
+    /* 
+     * make sure, that the masking operations in 
+     * ICTL and MSR are executed in order
+     */
+    asm volatile("sync":::"memory");
+
     /*
      * restore initial masks
Index: c/src/lib/libbsp/powerpc/gen83xx/network/network.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/network/network.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/network/network.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -27,8 +27,14 @@
 #include <stdio.h>
 
-#define TSEC_BITRATE 1000
 #define TSEC_IFMODE_RGMII 0
 #define TSEC_IFMODE_GMII  1
+
+#if defined(MPC8349EAMDS)
+#define TSEC_IFMODE TSEC_IFMODE_GMII
+#endif
+
+#if defined(HSC_CM01)
 #define TSEC_IFMODE TSEC_IFMODE_RGMII
+#endif
 
 /*=========================================================================*\
@@ -62,4 +68,5 @@
   }
   if (attaching) {
+#if (TSEC_IFMODE==TSEC_IFMODE_GMII)
     if (unitNumber == 1) {
       /*
@@ -74,11 +81,18 @@
 			       |                         0x0000001f);
     }
-  }
-  if (unitNumber == 2) {
+    if (unitNumber == 2) {
+      /*
+       * init port registers (GPIO2DIR) for TSEC2
+       */
+      mpc83xx.gpio[0].gpdir = ((mpc83xx.gpio[0].gpdir & ~0x000FFFFF)
+			       |                         0x00087881);
+    }
+#endif
+#if (TSEC_IFMODE==TSEC_IFMODE_RGMII)
+
     /*
-     * init port registers (GPIO2DIR) for TSEC2
+     * Nothing special needed for TSEC1 operation
      */
-    mpc83xx.gpio[0].gpdir = ((mpc83xx.gpio[0].gpdir & ~0x000FFFFF)
-			     |                         0x00087881);
+#endif    
   }
   /*
Index: c/src/lib/libbsp/powerpc/gen83xx/preinstall.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/preinstall.am	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/preinstall.am	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -82,4 +82,8 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/irq.h
 
+$(PROJECT_INCLUDE)/bsp/hwreg_vals.h: ./include/hwreg_vals.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/hwreg_vals.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/hwreg_vals.h
+
 $(PROJECT_INCLUDE)/bsp/vectors.h: ../../powerpc/shared/vectors/vectors.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/vectors.h
Index: c/src/lib/libbsp/powerpc/gen83xx/spi/spi_init.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/spi/spi_init.c	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/spi/spi_init.c	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -22,6 +22,8 @@
 #include <bsp.h>
 #if defined(MPC8349EAMDS)
-#include <libchip/i2c-2b-eeprom.h>
 #include <libchip/spi-flash-m25p40.h>
+#endif
+#if defined(HSC_CM01)
+#include <libchip/spi-fram-fm25l256.h>
 #endif
 
@@ -190,5 +192,6 @@
     reg_ptr:	 &mpc83xx.spi,
     initialized: FALSE,
-    irq_number:  BSP_IPIC_IRQ_SPI
+    irq_number:  BSP_IPIC_IRQ_SPI,
+    base_frq  :  0 /* filled in during init */
   }
 };
@@ -248,4 +251,9 @@
   mpc83xx.gpio[0].gpdr  &= ~(0xf << (31-27));
 #endif
+  /*
+   * update base frequency in spi descriptor
+   */
+  bsp_spi_bus_desc.softc.base_frq = BSP_bus_frequency;
+
   /*
    * register SPI bus
@@ -257,8 +265,8 @@
   }
   spi_busno = ret_code;
-  /*
-   * register M25P40 Flash, when available
-   */
-#if defined(MPC8349EAMDS)
+#if defined(MPC8349EAMDS)
+  /*
+   * register M25P40 Flash
+   */
   ret_code = rtems_libi2c_register_drv(RTEMS_BSP_SPI_FLASH_DEVICE_NAME,
 				       spi_flash_m25p40_rw_driver_descriptor,
@@ -268,4 +276,15 @@
   }
 #endif
+#if defined(HSC_CM01)
+  /*
+   * register FM25L256 FRAM
+   */
+  ret_code = rtems_libi2c_register_drv(RTEMS_BSP_SPI_FRAM_DEVICE_NAME,
+				       spi_fram_fm25l256_rw_driver_descriptor,
+				       spi_busno,0x02);
+  if (ret_code < 0) {
+    return -ret_code;
+  }
+#endif
   /*
    * FIXME: further drivers, when available
Index: c/src/lib/libbsp/powerpc/gen83xx/start/start.S
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/start/start.S	(revision 8ac748c1bfcb931c9e511cafbd1edbba14beb586)
+++ c/src/lib/libbsp/powerpc/gen83xx/start/start.S	(revision 42bf1b9f13d9269d9a98de4bdc1a11365865ef42)
@@ -86,4 +86,5 @@
 .extern MBAR   
 
+#if defined(RESET_CONF_WRD_L)
 .section ".resconf","ax"
 PUBLIC_VAR (reset_conf_words)
@@ -98,4 +99,5 @@
 	REP8( .byte ((RESET_CONF_WRD_H >>  8) & 0xff))
 	REP8( .byte ((RESET_CONF_WRD_H >>  0) & 0xff))
+#endif
 
 .section ".vectors","ax"
@@ -146,5 +148,4 @@
 	*/
 	/*
-	 * FIXME:	 
 	 * we start from 0x100, so ROM is currently mapped to
 	 * 0x00000000..
@@ -224,4 +225,5 @@
 	SET_IMM_REGW r31,r30,OR3_OFF,OR3_VAL
 #endif
+	
 	/*
 	 * ROM startup: init SDRAM access window
@@ -240,6 +242,18 @@
 #endif
 	/*
+	 * ROM startup: init refresh interval
+	 */
+#ifdef MRPTR_VAL
+	SET_IMM_REGW r31,r30,MRPTR_OFF,MRPTR_VAL
+#endif	
+	/*
 	 * ROM startup: init SDRAM
 	 */
+#ifdef LSRT_VAL
+	SET_IMM_REGW r31,r30, LSRT_OFF, LSRT_VAL
+#endif
+#ifdef LSDMR_VAL
+	SET_IMM_REGW r31,r30, LSDMR_OFF, LSDMR_VAL
+#endif
 #ifdef CS0_BNDS_VAL
 	SET_IMM_REGW r31,r30,CS0_BNDS_OFF,CS0_BNDS_VAL
@@ -278,6 +292,6 @@
 	SET_IMM_REGW r31,r30,TIMING_CFG_2_OFF,TIMING_CFG_2_VAL
 #endif
-#ifdef DDR_SDRAM_CFG_VAL
-	SET_IMM_REGW r31,r30,DDR_SDRAM_CFG_OFF,DDR_SDRAM_CFG_VAL
+#ifdef DDRCDR_VAL
+	SET_IMM_REGW r31,r30,DDRCDR_OFF,DDRCDR_VAL
 #endif
 #ifdef DDR_SDRAM_CFG_2_VAL
@@ -299,37 +313,121 @@
 	SET_IMM_REGW r31,r30,DDR_SDRAM_CLK_CNTL_OFF,DDR_SDRAM_CLK_CNTL_VAL
 #endif
+#ifdef DDR_SDRAM_CFG_2_VAL
+	SET_IMM_REGW r31,r30,DDR_SDRAM_CFG_2_OFF,DDR_SDRAM_CFG_2_VAL|DDR_SDRAM_CFG_2_D_INIT
+#endif
+
+#ifdef DDR_ERR_DISABLE_VAL
+	/*
+	 * disable detect of RAM errors
+	 */
+	SET_IMM_REGW r31,r30,DDR_ERR_DISABLE_OFF,DDR_ERR_DISABLE_VAL
+#endif
+#ifdef DDR_SDRAM_DATA_INIT_VAL
+	/*
+	 * set this value to initialize memory
+	 */
+	SET_IMM_REGW r31,r30,DDR_SDRAM_DATA_INIT_OFF,DDR_SDRAM_DATA_INIT_VAL
+#endif
 #ifdef DDR_SDRAM_INIT_ADDR_VAL
 	SET_IMM_REGW r31,r30,DDR_SDRAM_INIT_ADDR_OFF,DDR_SDRAM_INIT_ADDR_VAL
 #endif
-	/*
-	 * FIXME: ROM startup: perform mode set commands etc for SDRAM
-	 */
-	/*
-	 * ROM startup: copy code to SDRAM
-	 */
-	LA	r30, _text_start  /* get start address of text section in RAM */
-	add	r30, r20, r30    /* get start address of text section in ROM (add reloc offset) */
-	LA	r29, _text_start /* get start address of text section in RAM */
-	LA	r28, _text_size  /* get size of RAM image */
-	bl	copy_image      /* copy text section from ROM to RAM location */
-	
-	/*
-	 * FIXME: ROM startup: copy data to SDRAM
-	 */
-	LA	r30, _data_start /* get start address of data section in RAM */
-	add	r30, r20, r30    /* get start address of data section in ROM (add reloc offset) */
-	LA	r29, _data_start /* get start address of data section in RAM */
-	LA	r28, _data_size  /* get size of RAM image */
-	bl	copy_image       /* copy initialized data section from ROM to RAM location */
+#ifdef DDR_SDRAM_CFG_VAL
+	/*
+	 * config DDR SDRAM
+	 */
+	SET_IMM_REGW r31,r30,DDR_SDRAM_CFG_OFF,DDR_SDRAM_CFG_VAL & ~DDR_SDRAM_CFG_MEM_EN
+	/*
+	 * FIXME: wait 200us
+	 */
+	/*
+	 * enable  DDR SDRAM
+	 */
+	SET_IMM_REGW r31,r30,DDR_SDRAM_CFG_OFF,DDR_SDRAM_CFG_VAL | DDR_SDRAM_CFG_MEM_EN
+	/*
+	 * wait, until DDR_SDRAM_CFG_2_D_INIT is cleared
+	 */
+1:	lwz r30,DDR_SDRAM_CFG_2_OFF(r31)
+	andi. r30,r30,DDR_SDRAM_CFG_2_D_INIT
+	bne 1b
+#endif
+#ifdef DDR_ERR_DISABLE_VAL2
+	/*
+	 * enable detect of some RAM errors
+	 */
+	SET_IMM_REGW r31,r30,DDR_ERR_DISABLE_OFF,DDR_ERR_DISABLE_VAL2
+#endif
+#ifdef DDR_SDRAM_INTERVAL_VAL
+	/*
+	 * set the refresh interval
+	 */
+	SET_IMM_REGW r31,r30,DDR_SDRAM_INTERVAL_OFF,DDR_SDRAM_INTERVAL_VAL
+#endif
+start_rom_skip:
+	/*
+	 * determine current execution address offset
+	 */
+	bl start_rom_skip1
+start_rom_skip1:
+	mflr r20
+	LA   r30,start_rom_skip1
+	sub. r20,r20,r30	
+	/*
+	 * execution address offset == 0?
+	 * then do not relocate code and data
+	 */
+	beq  start_code_in_ram
+	/*
+	 * ROM or relocatable startup: copy startup code to SDRAM
+	 */
+	/* get start address of text section in RAM */
+	LA	r29, _text_start  
+	/* get start address of text section in ROM (add reloc offset) */
+	add	r30, r20, r29    
+	/* get size of startup code */
+	LA	r28, end_reloc_startup
+	LA	r31, _text_start
+	sub	28,r28,r31
+	/* copy startup code from ROM to RAM location */
+	bl	copy_image      
+	
 	/*
 	 * ROM startup: jump to code copy in  SDRAM
 	 */
-	LA	r29, start_code_in_ram /* get compile time address of label */
+	/* get compile time address of label */
+	LA	r29, copy_rest_of_text 
 	mtlr	r29
 	blr                     /* now further execution RAM */
+copy_rest_of_text:	
+#ifdef LCRR_VAL
+	SET_IMM_REGW r31,r30,LCRR_OFF,LCRR_VAL
+#endif
+	/*
+	 * ROM or relocatable startup: copy rest of code to SDRAM
+	 */
+	/* get start address of rest of code in RAM */
+	LA	r29, end_reloc_startup
+	/* get start address of text section in ROM (add reloc offset) */
+	add	r30, r20, r29    
+	/* get size of rest of code */
+	LA	r28, _text_start
+	LA	r31, _text_size
+	add	r28,r28,r31
+	sub	r28,r28,r29
+	bl	copy_image      /* copy text section from ROM to RAM location */
+	
+	/*
+	 * ROM or relocatable startup: copy data to SDRAM
+	 */
+	/* get start address of data section in RAM */
+	LA	r29, _data_start 
+	/* get start address of data section in ROM (add reloc offset) */
+	add	r30, r20, r29    
+	/* get size of RAM image */
+	LA	r28, _data_size  
+	/* copy initialized data section from ROM to RAM location */
+	bl	copy_image       
 
 start_code_in_ram:	
 
-start_rom_skip:	
 	/*
 	 * ROM/RAM startup: clear bss in SDRAM
@@ -418,2 +516,3 @@
 clr_mem_end:
         blr					/* return */
+end_reloc_startup:
